#ifndef GTKMM_MY_EVENT_H
#define GTKMM_MY_EVENT_H

#include <gtkmm/window.h>
#include <gtkmm/box.h>
#include <gtkmm/button.h>
#include <gtkmm/drawingarea.h>

struct Frame // Model Framing and window parameters
{
	double xMin; // frame parameters
	double xMax;
	double yMin;
	double yMax;
	double asp;  // frame aspect ratio
	int height;  // window height
	int width;   // window width
};

class MyArea : public Gtk::DrawingArea
{
public:
	MyArea();
	virtual ~MyArea();
	
	void clear();
	void draw();
    void setFrame(Frame x); 
    void adjustFrame(int width, int height);

protected:
	void on_draw(const Cairo::RefPtr<Cairo::Context>& cr, int width, int height);

private:
    Frame frame;
	bool empty;
};

class MyEvent : public Gtk::Window
{
public:
	MyEvent();

protected:
	//Button Signal handlers:
	void on_button_clicked_clear();
	void on_button_clicked_draw();

	MyArea m_Area;

	Gtk::Box m_Main_Box;
	Gtk::Box m_Buttons_Box;
	Gtk::Button m_Button_Clear;
	Gtk::Button m_Button_Draw;
};

#endif // GTKMM_MY_EVENT_H
